package unittest

import (
	"database/sql"
	"fmt"
	"xugugodriver/go_unit/unittest"

	"testing"
)

func TestDbExec_Insert_Guid_NULL(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1001
	testdb.Exec("delete GO_UNIT_GUID_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_GUID_DEAL VALUES(?,?)", rowid, nil)
	var equalsql = fmt.Sprintf("select count(*) from GO_UNIT_GUID_DEAL where id = %d and G1 IS NULL;", rowid)
	var equalrow = testdb.QueryRow(equalsql)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Guid_NULL FAIL.")
	}
	testdb.Close()
}

func TestDbExec_Insert_Guid_char(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1002
	var g1 = "0941BCBD12CF4DF18EB27AEF709B3624"
	testdb.Exec("delete GO_UNIT_GUID_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_GUID_DEAL VALUES(?,?)", rowid, g1)
	var equalrow = testdb.QueryRow("select count(*) from GO_UNIT_GUID_DEAL where id = ? and g1 = ?;", rowid, g1)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Guid_char FAIL.")
	}
	testdb.Close()
}
