package unittest

import (
	"database/sql"
	"fmt"
	"testing"
	"xugugodriver/go_unit/unittest"
)

func TestDbExec_Insert_Interval1_NULL(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1001
	testdb.Exec("delete GO_UNIT_INTERVAL1_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_INTERVAL1_DEAL VALUES(?,?,?,?,?,?,?)", rowid, nil, nil, nil, nil, nil, nil)
	var equalsql = fmt.Sprintf("select count(*) from GO_UNIT_INTERVAL1_DEAL where id = %d and IY IS NULL AND IM IS NULL AND ITD IS NULL AND IH IS NULL AND IMIN IS NULL AND ITS IS NULL ;", rowid)
	var equalrow = testdb.QueryRow(equalsql)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Interval1_NULL FAIL.")
	}
	testdb.Close()
}

func TestDbExec_Insert_Interval1_0(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1002
	var iy = 0
	var im = 0
	var itd = 0
	var ih = 0
	var imin = 0
	var its = 0
	testdb.Exec("delete GO_UNIT_INTERVAL1_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_INTERVAL1_DEAL VALUES(?,?,?,?,?,?,?)", rowid, iy, im, itd, ih, imin, its)
	var equalrow = testdb.QueryRow("select count(*) from GO_UNIT_INTERVAL1_DEAL where id = ? and iy = ? AND im = ? AND itd = ? AND ih = ? AND imin = ? AND iTS = ?;",
		rowid, iy, im, itd, ih, imin, its)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Interval1_0 FAIL.")
	}
	testdb.Close()
}

func TestDbExec_Insert_Interval1_Max(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1003
	var iy = 9999
	var im = 99999
	var itd = 999999
	var ih = 9999999
	var imin = 99999999
	var its = 999999999
	testdb.Exec("delete GO_UNIT_INTERVAL1_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_INTERVAL1_DEAL VALUES(?,?,?,?,?,?,?)", rowid, iy, im, itd, ih, imin, its)
	var equalrow = testdb.QueryRow("select count(*) from GO_UNIT_INTERVAL1_DEAL where id = ? and iy = ? AND im = ? AND itd = ? AND ih = ? AND imin = ? AND iTS = ?;",
		rowid, iy, im, itd, ih, imin, its)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Interval1_0 FAIL.")
	}
	testdb.Close()
}

func TestDbExec_Insert_Interval1_Min(t *testing.T) {
	testdb, err := sql.Open("xugusql", unittest.Dsn)
	if err != nil {
		fmt.Printf("[ERROR] %s\n", err.Error())
	}
	var rowid = 1004
	var iy = -9999
	var im = -99999
	var itd = -999999
	var ih = -9999999
	var imin = -99999999
	var its = -999999999
	testdb.Exec("delete GO_UNIT_INTERVAL1_DEAL where id = ?", rowid)
	testdb.Exec("INSERT INTO GO_UNIT_INTERVAL1_DEAL VALUES(?,?,?,?,?,?,?)", rowid, iy, im, itd, ih, imin, its)
	var equalrow = testdb.QueryRow("select count(*) from GO_UNIT_INTERVAL1_DEAL where id = ? and iy = ? AND im = ? AND itd = ? AND ih = ? AND imin = ? AND iTS = ?;",
		rowid, iy, im, itd, ih, imin, its)
	var row_count int32
	equalrow.Scan(&row_count)
	if row_count != 1 {
		t.Errorf("TestDbExec_Insert_Interval1_0 FAIL.")
	}
	testdb.Close()
}
